"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class RareDiseaseExitQuestionnaire(ProtocolElement):
    """
    The rare disease program exit questionnaire
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "eventDate",
        "familyLevelQuestions",
        "reporter",
        "variantGroupLevelQuestions",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_3 import reports as reports_6_7_2

        return {
            "familyLevelQuestions": reports_6_7_2.FamilyLevelQuestions,
            "variantGroupLevelQuestions": reports_6_7_2.VariantGroupLevelQuestions,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_3 import reports as reports_6_7_2

        return {
            "org.gel.models.report.avro.FamilyLevelQuestions": reports_6_7_2.FamilyLevelQuestions,
            "org.gel.models.report.avro.VariantGroupLevelQuestions": reports_6_7_2.VariantGroupLevelQuestions,
            "org.gel.models.report.avro.RareDiseaseExitQuestionnaire": reports_6_7_2.RareDiseaseExitQuestionnaire,
        }

    __slots__ = [
        "eventDate",
        "familyLevelQuestions",
        "reporter",
        "variantGroupLevelQuestions",
    ]

    def __init__(
        self,
        eventDate,
        familyLevelQuestions,
        reporter,
        variantGroupLevelQuestions,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_7_2.RareDiseaseExitQuestionnaire model.

        :param eventDate:
            The date when the questionnaire was submitted
        :type eventDate: str
        :param familyLevelQuestions:
            The set of questions at family level
        :type familyLevelQuestions: FamilyLevelQuestions
        :param reporter:
            The person that submitted the questionnaire
        :type reporter: str
        :param variantGroupLevelQuestions:
            The list of variant group level variants (ungrouped variants are to be
            set in single variant group)
        :type variantGroupLevelQuestions: list[VariantGroupLevelQuestions]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.7.2"
